#ifndef __defines__
#define __defines__

#define NAME                      server_name

#define ERR_NOT_ENOUGH_PARAMETERS ":%s 461 %s %s :Not enough parameters (%s)\r\n"
#define ERR_UNKNOWN_COMMAND       ":%s 421 %s %s :Unknown command\r\n"
#define ERR_ALREADY_REGISTERED    ":%s 462 %s :You may not reregister\r\n"
#define ERR_NOTREGISTERED         ":%s 451 %s :You have not registered\r\n"
#define ERR_NICKNAMEINUSE         ":%s 433 %s %s :Nickname already in use\r\n"
#define ERR_NORECIPIENT           ":%s 411 %s :No recepients (%s)\r\n"
#define ERR_NOTEXTTOSEND          ":%s 412 %s :No text to send\r\n"
#define ERR_BANNEDFROMCHAN        ":%s 474 %s %s :Banned from channel (+b)\r\n"
#define ERR_INVITEONLYCHAN        ":%s 473 %s %s :Invite only channel (+i)\r\n"
#define ERR_BADCHANNELKEY         ":%s 475 %s %s :Cannot join channel (+k)\r\n"
#define ERR_CHANNELISFULL         ":%s 471 %s %s :Channel is full (+l)\r\n"
#define ERR_NOSUCHCHANNEL         ":%s 403 %s %s :No such channel\r\n"
#define ERR_TOOMANYCHANNELS       ":%s 405 %s %s :You have joined too many channels\r\n"
#define ERR_NOPRIVELIGES          ":%s 481 %s :Permission denied - You are not an IRC operator\r\n"
#define RPL_WHOISUSER             ":%s 311 %s %s %s %s * :%s\r\n"
#define RPL_WHOISSERVER           ":%s 312 %s %s %s :%s\r\n"
#define RPL_WHOISOPERATOR         ":%s 313 %s %s :Is an IRC operator\r\n"
#define RPL_WHOISIDLE             ":%s 317 %s %s %i %i :seconds idle, signon time\r\n"
#define RPL_ENDOFWHOIS            ":%s 318 %s %s :End of /WHOIS\r\n"
#define RPL_WHOISCHANNELS         ":%s 319 %s %s :%s\r\n"
#define RPL_AWAY                  ":%s 301 %s %s :%s\r\n"
#define CHANNEL_FORMAT            "%c%s "
#define ERR_NOSUCHNICK            ":%s 401 %s %s :No such nickname\r\n"
#define RPL_WELCOME               ":%s 001 %s :Welcome to the Internet Relay Network %s\r\n"
#define RPL_HOST                  ":%s 002 %s :Your host is %s[%s], running version %s\r\n"
#define RPL_CREATED               ":%s 003 %s :This server was created %s\r\n"
#define RPL_LONGVERSION           ":%s 004 %s %s %s %s %s\r\n"
#define RPL_LUSERCLIENT           ":%s 251 %s :There are %i users and %i invisible on %i servers\r\n"
#define RPL_LUSEROPER             ":%s 252 %s %i :operator(s) online\r\n"
#define RPL_LUSERCHANNELS         ":%s 254 %s %i :channel(s) formed\r\n"
#define RPL_LUSERME               ":%s 255 %s :I have %i clients and %i servers\r\n"
#define RPL_HIGHESTUSERS          ":%s NOTICE %s :Highest connection count: %i (%i clients)\r\n"
#define VERSION                   "0.3.6"
#define CHANMODES                 "beIiklmnopstv"	/* biklmnopstv working */
#define USERMODES                 "bcdgkioswx"	/* owg working, i does something */
#define CREATE_DATE               __DATE__ " " __TIME__
#define RPL_YOUREOPER             ":%s 381 %s :You are now an IRC operator\r\n"
#define ERR_NOOPERHOST            ":%s 491 %s :No O-lines for your host\r\n"
#define ERR_PASSWDMISMATCH        ":%s 464 %s :Password incorrect\r\n"
#define RPL_OPERMODE              ":%s!%s@%s MODE %s :+o\r\n"
#define PRIVMSG                   ":%s!%s@%s PRIVMSG %s :%s\r\n"
#define NOTICE                    ":%s!%s@%s NOTICE %s :%s\r\n"
#define ERR_CANNOTSENDTOCHAN      ":%s 404 %s %s :Cannot send to channel\r\n"
#define WALLOPS                   ":%s!%s@%s WALLOPS :%s\r\n"
#define GLOBOPS                   ":%s NOTICE %s :Global from %s -- %s\r\n"
#define PING_REPLY                ":%s PONG %s :%s\r\n"
#define ERR_NO_ORIGIN             ":%s 409 %s :No origin specified\r\n"
#define RPL_TOPIC                 ":%s 332 %s %s :%s\r\n"
#define RPL_NOTOPIC               ":%s 331 %s %s :No topic is set.\r\n"
#define RPL_JOIN                  ":%s!%s@%s JOIN %s\r\n"
#define RPL_TOPICSET              ":%s 333 %s %s %s %i\r\n"
#define RPL_CHANNELCREATEDAT      ":%s 329 %s %s %i\r\n"
#define RPL_LISTSTART             ":%s 321 %s Channel :Users Topic\r\n"
#define RPL_LIST                  ":%s 322 %s %s %i :%s\r\n"
#define RPL_LIST_PRV              ":%s 322 %s Prv %i :\r\n"
#define RPL_LISTEND               ":%s 323 %s :End of /LIST\r\n"
#define RPL_WHOREPLY              ":%s 352 %s %s %s %s %s %s %c%s :%i %s\r\n"
#define RPL_ENDOFWHO              ":%s 315 %s %s :End of /WHO list\r\n"
#define ERR_UNKNOWNMODEFLAG       ":%s 472 %s %c :is an unknown mode char to me\r\n"
#define RPL_MODECHANOPADD         ":%s!%s@%s MODE %s +o %s\r\n"
#define RPL_MODECHANOPDEL         ":%s!%s@%s MODE %s -o %s\r\n"
#define RPL_MODECHANVOICEADD      ":%s!%s@%s MODE %s +v %s\r\n"
#define RPL_MODECHANVOICEDEL      ":%s!%s@%s MODE %s -v %s\r\n"
#define ERR_USERNOTONCHANNEL      ":%s 441 %s %s %s :User not in channel\r\n"
#define ERR_KEYSET                ":%s 467 %s %s :Key already set\r\n"
#define ERR_UMODEUNKNOWNFLAG      ":%s 501 %s :Unknown mode flag %c\r\n"
#define RPL_UMODEIS               ":%s 221 %s %s\r\n"
#define ERR_CHANOPRIVSNEEDED      ":%s 482 %s %s :You aren't channel operator\r\n"
#define RPL_VERSION               ":%s 351 %s %s %s :%s\r\n"
#define RPL_INFO                  ":%s 371 %s :%s\r\n"
#define RPL_INFO2                 ":%s 371 %s :%s: %s\r\n"
#define RPL_INFO3                 ":%s 371 %s :%s: %i bytes\r\n"
#define RPL_INFOEND               ":%s 374 %s :End of /INFO\r\n"
#define RPL_INFOMODHDR            ":%s 371 %s :Modules loaded:\r\n"
#define RPL_INFOMOD               ":%s 371 %s :Name: %s\r\n"
#define RPL_INFOMOD2              ":%s 371 %s :Description: %s\r\n"
#define RPL_INFOMOD3              ":%s 371 %s :Version: %s\r\n"
#define ERR_USERONCHANNEL         ":%s 443 %s %s %s :User already on channel\r\n"
#define ERR_NOTONCHANNEL          ":%s 442 %s %s :Not on channel\r\n"
#define RPL_INVITING              ":%s 341 %s %s %s\r\n"
#define RPL_UNAWAY                ":%s 305 %s :You are no longer marked as being away\r\n"
#define RPL_NOWAWAY               ":%s 306 %s :You are now marked as being away\r\n"
#define RPL_STATSOLINE            ":%s 243 %s %c %s * %s\r\n"
#define RPL_STATSPLINE            ":%s 217 %s P %i (%s)\r\n"
#define RPL_STATSMREPLY           ":%s 212 %s %s %i %i\r\n"
#define RPL_STATSUREPLY           ":%s 242 %s :Server up %i days, %.2d:%.2d:%.2d\r\n"
#define RPL_250                   ":%s 250 %s :Highest connection count: %i (%i clients)\r\n"
#define RPL_ADMINME               ":%s 256 %s %s :Adminstrative info\r\n"
#define RPL_ADMINLOC1             ":%s 257 %s :%s\r\n"
#define RPL_ADMINLOC2             ":%s 258 %s :%s\r\n"
#define RPL_ADMINEMAIL            ":%s 259 %s :%s\r\n"
#define ERR_NOADMININFO           ":%s 423 %s %s :No administrative info availiable\r\n"
#define RPL_LINKS                 ":%s 364 %s %s %s :%i %s\r\n"
#define RPL_ENDOFLINKS            ":%s 365 %s %s :End of /LINKS list\r\n"
#define RPL_TIME                  ":%s 391 %s %s %i :%s\r\n"

#ifdef DEBUGALL
#define DEBUGMEM
#define DEBUGMAIN
#define DEBUGSOCK
#endif

#ifdef SOLARIS
#undef calloc
#define calloc(x) _calloc(x)
#endif

#endif /* !__defines__ */
