#ifndef _dl_h_
#define _dl_h_

/*
 * dl.h
 * dynamic runtime library loading routines
 */

#include <dlfcn.h>
#include <stdio.h>
#include <string.h>
#include "struct.h"
#include "log.h"

struct functions {
     char *cmd_name;
     int (*function) (struct fd_list * fd, char **av, int ac);
     int need_registered;
     int need_unregistered;
     int need_oper;
};

struct functions_2 {
     void (*function) (struct fd_list * fd);
};

struct functions_3 {
     struct functions_2 *connect, *signon, *signoff;
};

typedef struct functions_3 EventFnList;

typedef struct functions_2 EventFunctions;
typedef struct functions Functions;

struct mod_info {
     char *module_name;
     char *module_description;
     char *module_version;
};

typedef struct mod_info Module_Info;

struct module {
     struct module *prev;
     struct module *next;
     Module_Info *info;
     Functions *function_list;
     EventFnList *other_funcs;
     int (*register_handler)(struct fd_list *);
     void *dl_handle;

};

typedef struct module Module;

extern Module *module_list;

struct path {
     struct path *prev;
     struct path *next;
     char dl_path[100];
};

typedef struct path LD_Path;

extern void __init_mod_list();
extern int load_module(char *path);
extern int unload_module(char *module_name);
extern int add_ld_path(char *path);

#endif /* !_dl_h_ */
