#include <stdio.h>
#include "struct.h"
#include "defines.h"
#include "irc_printf.h"

#define fprintf irc_fprintf
#define fflush irc_fflush

void __not_enough_parameters(struct fd_list *fd, char *cmd)
{
     if (fd->nick[0] != 0) {
	  fprintf(fd->sok, ERR_NOT_ENOUGH_PARAMETERS, NAME, fd->nick, cmd, cmd);
     } else {
	  fprintf(fd->sok, ERR_NOT_ENOUGH_PARAMETERS, NAME, "*", cmd, cmd);
     }
     fflush(fd->sok);
}

void __unknown_command(struct fd_list *fd, char *cmd)
{
     if (fd->nick[0] != 0) {
	  fprintf(fd->sok, ERR_UNKNOWN_COMMAND, NAME, fd->nick, cmd);
     } else {
	  fprintf(fd->sok, ERR_UNKNOWN_COMMAND, NAME, "*", cmd);
     }
     fflush(fd->sok);
}

void __already_registered(struct fd_list *fd)
{
     if (fd->nick[0] != 0) {
	  fprintf(fd->sok, ERR_ALREADY_REGISTERED, NAME, fd->nick);
     } else {
	  fprintf(fd->sok, ERR_ALREADY_REGISTERED, NAME, "*");
     }
     fflush(fd->sok);
}

void __not_registered(struct fd_list *fd)
{
     if (fd->nick[0] != 0) {
	  fprintf(fd->sok, ERR_NOTREGISTERED, NAME, fd->nick);
     } else {
	  fprintf(fd->sok, ERR_NOTREGISTERED, NAME, "*");
     }
     fflush(fd->sok);
}

void __nickname_in_use(struct fd_list *fd, char *nick)
{
     if (fd->nick[0] != 0) {
	  fprintf(fd->sok, ERR_NICKNAMEINUSE, NAME, fd->nick, nick);
     } else {
	  fprintf(fd->sok, ERR_NICKNAMEINUSE, NAME, "*", nick);
     }
     fflush(fd->sok);
}

void __no_recipient(struct fd_list *fd, char *cmd)
{
     if (fd->nick[0] != 0)
	  fprintf(fd->sok, ERR_NORECIPIENT, NAME, fd->nick, cmd);
     else
	  fprintf(fd->sok, ERR_NORECIPIENT, NAME, "*", cmd);
     fflush(fd->sok);
}

void __no_text_to_send(struct fd_list *fd)
{
     if (fd->nick[0] != 0)
	  fprintf(fd->sok, ERR_NOTEXTTOSEND, NAME, fd->nick);
     else
	  fprintf(fd->sok, ERR_NOTEXTTOSEND, NAME, "*");
     fflush(fd->sok);
}

void __banned_from_chan(struct fd_list *fd, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_BANNEDFROMCHAN, NAME, fd->nick, chan->name);
     fflush(fd->sok);
     return;
}

void __invite_only_chan(struct fd_list *fd, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_INVITEONLYCHAN, NAME, fd->nick, chan->name);
     fflush(fd->sok);
     return;
}

void __bad_chan_key(struct fd_list *fd, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_BADCHANNELKEY, NAME, fd->nick, chan->name);
     fflush(fd->sok);
     return;
}

void __chan_is_full(struct fd_list *fd, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_CHANNELISFULL, NAME, fd->nick, chan->name);
     fflush(fd->sok);
     return;
}

void __no_such_channel(struct fd_list *fd, char *chan)
{
     fprintf(fd->sok, ERR_NOSUCHCHANNEL, NAME, fd->nick, chan);
     fflush(fd->sok);
     return;
}

void __too_many_channels(struct fd_list *fd, char *name)
{
     fprintf(fd->sok, ERR_TOOMANYCHANNELS, NAME, fd->nick, name);
     fflush(fd->sok);
     return;
}

void __no_priveliges(struct fd_list *fd)
{
     fprintf(fd->sok, ERR_NOPRIVELIGES, NAME, fd->nick);
     fflush(fd->sok);
     return;
}

void __no_origin(struct fd_list *fd)
{
     fprintf(fd->sok, ERR_NO_ORIGIN, NAME, (fd->nick[0] != '\0' ? fd->nick : "*"));
     fflush(fd->sok);
     return;
}

void __user_on_channel(struct fd_list *fd, char *nick, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_USERONCHANNEL, NAME, fd->nick, nick, chan->name);
     fflush(fd->sok);
     return;
}

void __not_on_channel(struct fd_list *fd, struct chan_list *chan)
{
     fprintf(fd->sok, ERR_NOTONCHANNEL, NAME, fd->nick, chan->name);
     fflush(fd->sok);
     return;
}
