#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <syslog.h>

/* _calloc(int size)
   returns a pointer to a zeroed block of memory size bytes long
 */


void *
 _calloc(int size)
{
     void *ptr;

     ptr = malloc(size);
     if (ptr == NULL) {
	  error("couldn't allocate memory");
     }
     bzero(ptr, size);
     return ptr;
}

/* __free(ptr)
   frees ptr
 */

void __free(void *ptr)
{
     if (!ptr) {
	  fprintf(stderr, "can't free NULL!\n");
	  errno = EFAULT;
	  return;
     }
     free((void *) ptr);
}
