
#include <stdio.h>
#include "struct.h"
#include "defines.h"
#include <string.h>
#include "channels.h"
#include "mem.h"
#include "errors.h"
#include "user.h"
#include "stats.h"

extern struct msg_use msgs;
extern char *t, *tmp;

/* __mode_reply
   parses mode
 */

void __mode_reply(struct fd_list *fd, char *mode_str, char *dest, char **av, int ac)
{
     dest = av[1];

     if (dest[0] == '#') {
	  struct chan_list *list;
	  int arg;

	  arg = 3;

	  list = __clist_head->next;

	  if (ac >= 3) {
	       if (strlen(av[2]) == 0) {
		    mode_str = NULL;
		    fprintf(stderr, "mode_str is null\n");
	       } else {
		    mode_str = av[2];
		    fprintf(stderr, "mode_str is %s\n", mode_str);
	       }
	  } else {
	       mode_str = NULL;
	       fprintf(stderr, "mode_str is null\n");
	  }

	  while (list != NULL) {
	       if (!strcasecmp(dest, list->name)) {
		    if (mode_str == NULL) {
			 char cmode[15];
			 int i;

			 memset((void *) cmode, 0, 15);
			 cmode[0] = '+';
			 i = 1;
			 if (list->invite_only)
			      cmode[i++] = 'i';
			 if (list->key)
			      cmode[i++] = 'k';
			 if (list->limit)
			      cmode[i++] = 'l';
			 if (list->mute)
			      cmode[i++] = 'm';
			 if (list->no_outside_msg)
			      cmode[i++] = 'n';
			 if (list->private)
			      cmode[i++] = 'p';
			 if (list->secret)
			      cmode[i++] = 's';
			 if (list->oper_only_topic)
			      cmode[i++] = 't';
			 if (list->key && list->limit) {
			      irc_fprintf(fd->sok, ":%s 324 %s %s %s %s %i\r\n", NAME, fd->nick, list->name,
					  cmode, list->key_val, list->limit_val);
			 } else if (!list->limit && list->key) {
			      irc_fprintf(fd->sok, ":%s 324 %s %s %s %s\r\n", NAME, fd->nick, list->name,
					  cmode, list->key_val);
			 } else if (list->limit && !list->key) {
			      irc_fprintf(fd->sok, ":%s 324 %s %s %s %i\r\n", NAME, fd->nick, list->name,
					  cmode, list->limit_val);
			 } else {
			      irc_fprintf(fd->sok, ":%s 324 %s %s %s\r\n", NAME, fd->nick, list->name, cmode);
			 }
			 irc_fprintf(fd->sok, RPL_CHANNELCREATEDAT, NAME, fd->nick, list->name,
				     list->chan_created_at);
			 irc_fflush(fd->sok);
			 return;
		    } else if ((strlen(mode_str) == 1 &&
				mode_str[0] == 'b') ||
			       (strlen(mode_str) == 2 &&
				mode_str[1] == 'b')) {
			 char *ban;

			 if (ac == 3) {
			      ban = NULL;
			 } else {
			      ban = av[arg++];
			 }

			 if (ban == NULL) {
			      struct ban_list *bans;
			      char *fmt =
			      ":%s 367 %s %s %s %s %i\r\n";

			      bans = list->bans;
			      while (bans != NULL) {
				   irc_fprintf(fd->sok, fmt, NAME,
					       fd->nick, list->name,
					       bans->banid, bans->userid,
					       bans->time);
				   irc_fflush(fd->sok);
				   bans = bans->next;
			      }
			      irc_fprintf(fd->sok,
					  ":%s 368 %s %s :End of channel ban list\r\n",
					  NAME, fd->nick, list->name);
			      irc_fflush(fd->sok);
			      return;
			 } else {
			      if (strlen(mode_str) == 2) {
				   if (mode_str[0] == '+') {
					__add_channel_ban(fd, list, ban);
				   } else {
					__del_channel_ban(fd, list, ban);
				   }

			      } else {
				   __add_channel_ban(fd, list, ban);
			      }
			 }
			 return;
		    } else if ((strlen(mode_str) == 1 &&
				mode_str[0] == 'e') ||
			       (strlen(mode_str) == 2 &&
				mode_str[1] == 'e')) {
			 char *ban;

			 if (ac == 3) {
			      ban = NULL;
			 } else {
			      ban = av[arg++];
			 }

			 if (ban == NULL) {
			      struct ban_list *bans;
			      char *fmt =
			      ":%s 367 %s %s %s %s %i\r\n";

			      bans = list->exempts;
			      while (bans != NULL) {
				   irc_fprintf(fd->sok, fmt, NAME,
					       fd->nick, list->name,
					       bans->banid, bans->userid,
					       bans->time);
				   irc_fflush(fd->sok);
				   bans = bans->next;
			      }
			      irc_fprintf(fd->sok,
					  ":%s 368 %s %s :End of channel exempt list\r\n",
					  NAME, fd->nick, list->name);
			      irc_fflush(fd->sok);
			      return;
			 } else {
			      if (strlen(mode_str) == 2) {
				   if (mode_str[0] == '+') {
					__add_channel_exempt(fd, list, ban);
				   } else {
					__del_channel_exempt(fd, list, ban);
				   }

			      } else {
				   __add_channel_exempt(fd, list, ban);
			      }
			 }
			 return;
		    } else if ((strlen(mode_str) == 1 &&
				mode_str[0] == 'I') ||
			       (strlen(mode_str) == 2 &&
				mode_str[1] == 'I')) {
			 char *ban;

			 if (ac == 3) {
			      ban = NULL;
			 } else {
			      ban = av[arg++];
			 }

			 if (ban == NULL) {
			      struct ban_list *bans;
			      char *fmt =
			      ":%s 367 %s %s %s %s %i\r\n";

			      bans = list->perminvites;
			      while (bans != NULL) {
				   irc_fprintf(fd->sok, fmt, NAME,
					       fd->nick, list->name,
					       bans->banid, bans->userid,
					       bans->time);
				   irc_fflush(fd->sok);
				   bans = bans->next;
			      }
			      irc_fprintf(fd->sok,
					  ":%s 368 %s %s :End of channel perminvite list\r\n",
					  NAME, fd->nick, list->name);
			      irc_fflush(fd->sok);
			      return;
			 } else {
			      if (strlen(mode_str) == 2) {
				   if (mode_str[0] == '+') {
					__add_channel_perminvite(fd, list, ban);
				   } else {
					__del_channel_perminvite(fd, list, ban);
				   }

			      } else {
				   __add_channel_perminvite(fd, list, ban);
			      }
			 }
			 return;
		    } else {
			 int ok = 0;

			 {
			      struct user_list *users;

			      users = list->users;
			      while (users != NULL) {
				   if (users->user == fd) {
					if (users->oper == 1) {
					     ok = 1;
					     users = NULL;
					}
				   }
				   if (users != NULL)
					users = users->next;
			      }
			 }
			 if (ok) {
			      struct chan_mode_change *mode = __cmode_parse(fd, list, mode_str, av, ac, arg);

			      __set_cmode(fd, list, mode);
			      __free(mode);
			      return;
			 } else {
			      irc_fprintf(fd->sok, ERR_CHANOPRIVSNEEDED, NAME, fd->nick, list->name);
			      return;
			 }
		    }
	       }
	       list = list->next;
	  }

	  __no_such_channel(fd, dest);
	  return;
     } else {
	  if (ac < 3) {
	       mode_str = NULL;
	  } else {
	       if (strlen(av[2]) == 0) {
		    mode_str = NULL;
	       } else {
		    mode_str = av[2];
	       }
	  }

	  if (!strcasecmp(fd->nick, av[1])) {
	       if (mode_str == NULL) {
		    char umode[12];
		    int i;

		    memset((void *) umode, 0, 12);
		    umode[0] = '+';
		    i = 1;
		    if (fd->show_whois)
			 umode[i++] = 'b';
		    if (fd->show_connect)
			 umode[i++] = 'c';
		    if (fd->invisible)
			 umode[i++] = 'i';
		    if (fd->s_msg)
			 umode[i++] = 's';
		    if (fd->wallops)
			 umode[i++] = 'w';
		    if (fd->oper)
			 umode[i++] = 'o';
		    if (fd->deaf)
			 umode[i++] = 'd';
		    if (fd->globops)
			 umode[i++] = 'g';
		    if (fd->service)
			 umode[i++] = 'k';
		    if (fd->hide_hostname)
			 umode[i++] = 'x';
		    irc_fprintf(fd->sok, RPL_UMODEIS, NAME, fd->nick, umode);
		    return;
	       } else {
		    struct user_mode_change *umode = __parse_umode(fd, mode_str);

		    __set_umode(fd, umode);
		    __free(umode);
		    return;
	       }
	  } else {
	       irc_fprintf(fd->sok, ":%s 502 %s :Can't change mode for other users\r\n", server_name, fd->nick);
	       irc_fflush(fd->sok);
	       return;
	  }
     }
}

/* m_mode
   av[0] = "MODE"
   av[1] = nick/channel
   av[2] = mode change
   av[3...] = parameters
   handles a MODE command
 */

void m_mode(struct fd_list *fd, char **av, int ac)
{
     char *dest, *mode_str;

     msgs.mode.use++;
     msgs.mode.bytes += strlen(tmp);
     if (ac >= 2) {
	  dest = av[1];
	  mode_str = NULL;
	  __mode_reply(fd, mode_str, dest, av, ac);
     } else {
	  __not_enough_parameters(fd, t);
     }
     return;
}
