#include <stdio.h>
#include <string.h>
#include "struct.h"
#include "defines.h"
#include "stats.h"
#include "errors.h"
#include "user.h"

extern char *t, *tmp;
extern struct msg_use msgs;

void __send_wallops(struct fd_list *fd, char *msg)
{
     struct fd_list *list;
     char *my_hostname = (fd->hide_hostname ? "hidden.hurricane.net" : fd->hostname);

     list = __head->next;

     if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n')
	  msg[strlen(msg) - 1] = 0;
     if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n')
	  msg[strlen(msg) - 1] = 0;

     while (list != NULL) {
	  if (list->wallops) {
	       irc_fprintf(list->sok, WALLOPS, fd->nick, fd->userid, my_hostname, msg);
	       irc_fflush(list->sok);
	  }
	  list = list->next;
     }

     return;
}

void __send_globops(struct fd_list *fd, char *msg)
{
     struct fd_list *list;

     list = __head->next;

     if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n')
	  msg[strlen(msg) - 1] = 0;
     if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n')
	  msg[strlen(msg) - 1] = 0;

     while (list != NULL) {
	  if (list->globops && list->oper) {
	       irc_fprintf(list->sok, GLOBOPS, NAME, list->nick, fd->nick, msg);
	       irc_fflush(list->sok);
	  }
	  list = list->next;
     }

     return;
}

void m_sendmsg(struct fd_list *fd, char **av, int ac)
{
     char *dest, *msg;

     if (!strcasecmp(t, "PRIVMSG")) {
	  msgs.privmsg.use++;
	  msgs.privmsg.bytes += strlen(tmp);
     } else {
	  msgs.notice.use++;
	  msgs.notice.bytes += strlen(tmp);
     }
     if (ac < 3) {
	  if (ac == 2) {
	       if (strchr(av[1], ' ')) {
		    __no_recipient(fd, t);
	       } else {
		    __no_text_to_send(fd);
	       }
	  } else {
	       __not_enough_parameters(fd, t);
	  }
     } else {
	  dest = av[1];
	  msg = av[2];
	  if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n') {
	       msg[strlen(msg) - 1] = 0;
	  }
	  if (msg[strlen(msg) - 1] == '\r' || msg[strlen(msg) - 1] == '\n') {
	       msg[strlen(msg) - 1] = 0;
	  }
	  if (strchr(dest, ',')) {
	       char *nick;
	       int p = 1;

	       nick = strtok(dest, ",");
	       while (p) {
		    if (!strcasecmp(t, "PRIVMSG")) {
			 __send_privmsg(fd, nick, msg);
		    } else {
			 __send_notice(fd, nick, msg);
		    }
		    nick = strtok(NULL, ",");
		    if (nick == NULL)
			 p = 0;
	       }
	  } else {
	       if (!strcasecmp(t, "PRIVMSG")) {
		    __send_privmsg(fd, dest, msg);
	       } else {
		    __send_notice(fd, dest, msg);
	       }
	  }
     }
     return;
}

void m_wallops(struct fd_list *fd, char **av, int ac)
{
     msgs.wallops.use++;
     msgs.wallops.bytes += strlen(tmp);
     if (ac < 2) {
	  __not_enough_parameters(fd, t);
     } else {
	  __send_wallops(fd, av[1]);
     }
     return;
}

void m_globops(struct fd_list *fd, char **av, int ac)
{
     msgs.globops.use++;
     msgs.globops.bytes += strlen(tmp);
     if (ac < 2) {
	  __not_enough_parameters(fd, t);
     } else {
	  __send_globops(fd, av[1]);
     }
     return;
}
