#include "gc.h"
#include "struct.h"
#include "irc_printf.h"
#include <stdio.h>
#include <stdarg.h>

extern struct server_list me;

int sendto_user(struct fd_list *from, struct fd_list *to, char *fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	if (to->sptr != &me) {
		irc_fprintf(to->sok, ":%s ", from->nick);
		irc_vfprintf(to->sok, fmt, ap);
	} else {
		irc_fprintf(to->sok, ":%s!%s@%s ", from->nick, from->userid, from->hostname);
		irc_vfprintf(to->sok, fmt, ap)
	}
	va_end(ap);
	return 0;
}

int sendto_opers(char *fmt, ...) {
	struct fd_list *l = __head->next;
	va_list ap;

	va_start(ap, fmt);

	while (l) {
		if (l->oper) {
			irc_fprintf(to->sok, ":%s ", me.server_name);
			irc_vfprintf(to->sok, fmt, ap);
		}
		l = l->next;
	}

	va_end(ap);
	return 0;
}

int sendto_all(char *fmt, ...) {
	struct fd_list *l = __head->next;
	va_list ap;

	va_start(ap, fmt);
	while (l) {
		irc_fprintf(to->sok, ":%s ", me.server_name);
		irc_vfprintf(to->sok, fmt, ap);
		l = l->next;
	}

	va_end(ap);
	return 0;
}

int sendto_serv(struct server_list *to, char *fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	if (to != &me) {
		fprintf(to->sok, ":%s ", me.server_name);
		vfprintf(to->sok, fmt, ap);
	}
	va_end(ap);
	return 0;
}

